package cn.estsh.i3plus.ext.mes.pcn.apiservice.controller.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesConfigService;
import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesWorkOrderService;
import cn.estsh.i3plus.ext.mes.pcn.apiservice.schedulejob.MesReportNoSortJob;
import cn.estsh.i3plus.ext.mes.pcn.apiservice.schedulejob.MesReportWorkByPreDayJob;
import cn.estsh.i3plus.ext.mes.pcn.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.mes.bean.MesProductionRecord;
import cn.estsh.i3plus.pojo.mes.bean.MesShift;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import cn.estsh.i3plus.pojo.mes.repository.MesProductionRecordRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesShiftRepository;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/test")
public class TestController {

    @Autowired
    private MesReportNoSortJob mesReportNoSortJob;

    @Autowired
    private MesReportWorkByPreDayJob mesReportWorkByPreDayJob;

    @Autowired
    private IMesWorkOrderService workOrderService;

    @Autowired
    private MesProductionRecordRepository productionRecordRao;

    @Autowired
    private MesShiftRepository mesShiftRepository;

    @Autowired
    private IMesConfigService configService;

    @GetMapping("/reportWorkByPreDayJob")
    @ApiOperation(value = "查询设备交互")
    public ResultBean queryReworkTaskByPager(String organizeCode) {
        try {
            //遍历系统参数指定的产线获取对应班次，找到早班的开始时间，
            String workCenterCodes = configService.getCfgValue(organizeCode, "MES_PCN_WORK_CENTER_NO");
            List<String> workCenterCodeList = Arrays.asList(workCenterCodes.split(","));
            String userName = "REPORT_PRE_DAY_JOB";
            DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
            List<MesShift> mesShiftListAll = mesShiftRepository.findByHqlWhere(packBean);
            for (String workCenterCode : workCenterCodeList) {
                List<MesShift> mesShiftList = mesShiftListAll.stream().filter(s -> s.getWorkCenterCode().equalsIgnoreCase(workCenterCode)).collect(Collectors.toList());
                //1.获取生产加工记录production_record表中，report_status为待汇报状态的工单
                List<MesProductionRecord> mesProductionRecordList = workOrderService.getPreDayReportMesProductionRecord(organizeCode, mesShiftList, workCenterCode);
                if (CollectionUtils.isEmpty(mesProductionRecordList)) {
                    continue;
                }

                //3.插入生产工单表
                List<MesWorkOrder> mesWorkOrders = workOrderService.insertMesWorkOrder(mesProductionRecordList, mesShiftList, organizeCode, userName);
                if (CollectionUtils.isEmpty(mesWorkOrders)) {
                    continue;

                }
                //4.根据产线+物料产生的工单报工

                for (MesWorkOrder mesWorkOrder : mesWorkOrders) {
                    List<MesProductionRecord> mesProductionRecords = mesProductionRecordList.stream().filter(
                            w -> w.getWorkCenterCode().equalsIgnoreCase(mesWorkOrder.getWorkCenterCode())
                                    && w.getPartNo().equalsIgnoreCase(mesWorkOrder.getPartNo())).collect(Collectors.toList());
                    workOrderService.doPcnJobProductReport(mesProductionRecords, mesShiftList, organizeCode, userName, mesWorkOrder);
                }
                for (MesProductionRecord mesProductionRecord : mesProductionRecordList) {
                    mesProductionRecord.setReportStatus(20);
                    ConvertBean.serviceModelUpdate(mesProductionRecord, userName);
                }
                productionRecordRao.saveAll(mesProductionRecordList);

            }
            return ResultBean.success("查询成功").setResultList(null);
        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping("/reportOrder")
    @ApiOperation(value = "报工")
    public void reportOrder() {
        mesReportNoSortJob.executeMesJob(null, null);

    }

    @GetMapping("/reportOrder1")
    @ApiOperation(value = "报工")
    public void reportOrder1() {
        mesReportWorkByPreDayJob.executeMesJob(null, null);

    }

    @GetMapping("/MesReportSortJob")
    @ApiOperation(value = "排序工单汇报")
    public void doMesReportSortJob(String organizeCode,Integer pageSize,String userName) {
        workOrderService.doMesWorkOrderSortReport(organizeCode,pageSize,userName);
    }

    @GetMapping("/testInsert")
    @ApiOperation(value = "批量")
    public void testInsert() {
        //testService.insertList();

    }
}
