package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesEarlyWarningService;
import cn.estsh.i3plus.ext.mes.pcn.apiservice.util.MesPcnException;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesEarlyWarningKanBan;
import cn.estsh.i3plus.pojo.mes.model.MesEarlyWarningKanBanModel;
import cn.estsh.i3plus.pojo.mes.repository.MesEarlyWarningKanBanRepository;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.lang.reflect.InvocationTargetException;
import java.util.List;

@Slf4j
@Service
public class MesEarlyWarningServiceImpl implements IMesEarlyWarningService {

    @Autowired
    private MesEarlyWarningKanBanRepository earlyWarningKanBanRao;
    
    @Override
    public  List<MesEarlyWarningKanBan> getEarlyWarningList(String organizeCode) {

        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        return earlyWarningKanBanRao.findByHqlWhere(ddlPackBean);
    }

    @Override
    public void saveEarlyWarning(MesEarlyWarningKanBanModel model) {
        MesEarlyWarningKanBan kanBan = new MesEarlyWarningKanBan();
        try {
            BeanUtils.copyProperties(kanBan,model);
        } catch (IllegalAccessException | InvocationTargetException e) {
            log.error(e.getMessage());
            MesPcnException.throwMesBusiException("类型转换出错!"+e.getMessage());
        }
        ConvertBean.saveOrUpdate(kanBan,model.getCreateUser());
        earlyWarningKanBanRao.insert(kanBan);

    }

    @Override
    public void updateEarlyWarning(MesEarlyWarningKanBan earlyWarning) {
        ConvertBean.saveOrUpdate(earlyWarning,earlyWarning.getCreateUser());
        earlyWarningKanBanRao.insert(earlyWarning);

    }

    @Override
    public void deleteEarlyWarning(Long id, String organizeCode,String userName) {
        earlyWarningKanBanRao.deleteWeaklyByProperties(new String[]{"id","organizeCode"},new Object[]{id,organizeCode},userName);
    }

    @Override
    public MesEarlyWarningKanBan getKanbanData(Long id,String organizeCode) {
        List<MesEarlyWarningKanBan> list = earlyWarningKanBanRao.findByProperty(new String[]{"id", "organizeCode"}, new Object[]{id, organizeCode});
        if (!list.isEmpty()){
            return list.get(0);
        }
        return new MesEarlyWarningKanBan();
    }

    @Override
    public void getData(Long id, String organizeCode) {
        DdlPackBean earlyWarningKanBanPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getNumEqualPack(id,"id",earlyWarningKanBanPackBean);
        List<MesEarlyWarningKanBan> list = earlyWarningKanBanRao.findByHqlTopWhere(earlyWarningKanBanPackBean, 1);
        if (list.isEmpty()){
            //todo return;
        }

        MesEarlyWarningKanBan kanBan = list.get(0);
        //1.获取最近的20条v107信息
        DdlPackBean v107PackBean = DdlPackBean.getDdlPackBean(organizeCode);
//        DdlPreparedPack.
        //2.获取最新的一条报文信息

        //3.获取最新的一条报文信息

        //4.获取最新工位单号

        //5.获取最新下线工单

        //6.查询报警产量

        //7.获取开班起始时间

        //8.根据条件获取工单的数量
    }
}
